{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 64384,0,655360}

program FCK;

type arr = array [1..100,1..100,0..1] of byte;
     parr = ^arr;
     tqueue = array [0..21000] of byte;
     pqueue = ^tqueue;
var ys, xs: integer;
    m: array [0..51, 0..51] of byte;
    l: array [0..51, 0..51] of integer;
   qx, qy: array [0..21000] of byte;
    qb: Pqueue;
   qh, qt: integer;
    g: array [1..100, 1..100] of byte;
   ca: array [1..100] of byte;
    c: integer;
   so, ta: integer;
   w: Parr;

procedure ReadAll;
var i, j: integer;
    s: string;
begin
  fillchar (m, sizeof(m), 0);
  assign (input, 'input.txt');
  reset (input);
    readln (ys, xs);
    for i := 1 to ys do
    begin
      readln (s);
      for j := 1 to xs do
        m [j, i] := byte(s[j]) - 48;
    end;
  close (input);
end;

procedure PushCell (x, y, d: integer);
begin
  l [x, y] := d;
  inc (qh);
  qx [qh] := x;
  qy [qh] := y;
end;

procedure PushArea (x, y, d: integer);
var Lqt: integer;
    m0, x0, y0: integer;
begin
  Lqt := qh+1;
  PushCell (x, y, d);
  while lqt <= qh do
  begin
    x0 := qx [lqt]; y0 := qy [lqt]; m0 := m [x0, y0];
    inc (lqt);
    if (m [x0+1, y0] = m0) and (l [x0+1, y0] < 0) then PushCell (x0+1, y0, d);
    if (m [x0-1, y0] = m0) and (l [x0-1, y0] < 0) then PushCell (x0-1, y0, d);
    if (m [x0, y0+1] = m0) and (l [x0, y0+1] < 0) then PushCell (x0, y0+1, d);
    if (m [x0, y0-1] = m0) and (l [x0, y0-1] < 0) then PushCell (x0, y0-1, d);
  end;
end;

procedure ProcessQueue;
var l0, m0, x0, y0: integer;
begin
  while qt <= qh do
  begin
    x0 := qx [qt]; y0 := qy [qt]; l0 := l [x0, y0];
    inc (qt);
    if (l [x0+1, y0] < 0) then PushArea (x0+1, y0, l0+1);
    if (l [x0-1, y0] < 0) then PushArea (x0-1, y0, l0+1);
    if (l [x0, y0+1] < 0) then PushArea (x0, y0+1, l0+1);
    if (l [x0, y0-1] < 0) then PushArea (x0, y0-1, l0+1);
  end;
end;

procedure FillL;
var i, j: integer;
begin
  for i := 0 to xs+1 do
    for j := 0 to ys + 1 do
      l [i, j] := 0;
  for i := 1 to xs do
    for j := 1 to ys do
      l [i, j] := -1;
  qh := 0; qt := 1;
  PushArea (1, 1, 1);
  ProcessQueue;
end;

procedure TaskA;
var x: integer;
begin
  FillL;
  x := l[xs, ys]-2;
  if x < 0 then x := 0;
  writeln (x);
end;

procedure EnhanceGraph;
var i, j: integer;
begin
  for i := 1 to c do
    for j := 1 to c do
      if g[i,j] > 0 then
             g[j, i+c] := 1;
  for i := 1 to c do
  begin
    g[i, i+c] := 1;
    g[i+c, i] := 1;
    ca [i+c] := 0;
  end;
  c := c + c;
end;

procedure BuildGraph;
var i, j: integer;
begin
  for i := 1 to xs do
    for j := 1 to ys do
      l [i, j] := -1;
  fillchar (g, sizeof(g), 0);
  c := 0;
  for i := 1 to xs do
    for j := 1 to ys do
      if l [i, j] < 0 then
  begin
    inc (c);
    ca [c] := m[i, j];
    qh := 0;
    qt := 1;
    PushArea (i, j, c);
  end;
  for i := 1 to xs-1 do
    for j := 1 to ys do
      if l[i,j] <> l[i+1, j] then
        begin
          g[l[i,j], l[i+1, j]] := 1;
          g[l[i+1,j], l[i, j]] := 1;
        end;
  for i := 1 to xs do
    for j := 1 to ys-1 do
      if l[i,j] <> l[i, j+1] then
        begin
          g[l[i,j], l[i, j+1]] := 1;
          g[l[i,j+1], l[i, j]] := 1;
        end;
  so := l[1, 1];
  ta := l[xs, ys];
  EnhanceGraph;
end;

procedure PushPos (i, j, k, d: integer);
begin
  if w ^[i, j, k] < 255 then exit;
  w ^[i, j, k] := d;
  inc (qh);
  qx [qh] := i;
  qy [qh] := j;
  qb^ [qh] := k;
end;

procedure MarkPairs;
var i, j, k: integer;
begin
  qh := 0;
  qt := 1;
  for i := 1 to c do
    for j := 1 to c do
      for k := 0 to 1 do
      begin
        w ^[i, j, k] := 255;
        if g [i,j] > 0 then PushPos (i, j, k, 0);
      end;
end;

procedure ProcessPairQueue;
var bb, cc, i, j, i0, j0, k0, w0: integer;
begin
  while qt <= qh do
  begin
    if w^[so,ta,0] < 255 then exit;
    i0 := qx [qt]; j0 := qy [qt]; k0 := qb ^[qt];
    w0 := w ^[i0, j0, k0]; inc (qt);
    if k0 = 1 then
        begin
          for i := 1 to c do
            if (g [i0, i] > 0) and (ca[i] <> ca [j0]) then
              PushPos (i, j0, 1-k0, w0+1);
        end;
    if k0 = 0 then
        begin
          for j := 1 to c do
            if (g [j0, j] > 0) and (ca[j] <> ca [i0]) then
              PushPos (i0, j, 1-k0, w0+1);
        end;
  end;
end;

procedure TaskB;
begin
  BuildGraph;
  MarkPairs;
  ProcessPairQueue;
  writeln (w^[so, ta, 0]);
end;

procedure Solve;
var i, j: integer;
begin
  assign (output, 'output.txt');
  rewrite (output);
  TaskA;
  TaskB;
  close (output);
end;

begin
  new (w); new (qb);
  ReadAll;
  Solve;
  dispose (w); dispose (qb);
end.