{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

const
  lenMax = 100;
  pow = 10000;

type
  tNumber = record
              len : integer;
              num : array[1..lenMax] of word;
            end;

var
  f1, f2, temp : tNumber;
  i, N : integer;

procedure add(var a : tNumber; const b : tNumber);
var
  r : word;
  i : integer;
begin
  r := 0;
  if a.len < b.len then
    a.len := b.len;
  for i := 1 to a.len do begin
    inc(r, a.num[i]+b.num[i]);
    a.num[i] := r mod pow;
    r := r div pow;
  end;

  if r > 0 then begin
    inc(a.len);
    a.num[a.len] := 1;
  end;
end;

procedure print(const a : tNumber);
var
  i : integer;
  j : longint;
begin
  if a.len = 0 then
    write(0)
  else begin
    write(a.num[a.len]);
    for i := a.len-1 downto 1 do begin
      j := a.num[i]+ord(a.num[i]=0);
      while j*10 < pow do begin
        write(0);
        j := j*10;
      end;
      write(a.num[i]);
    end;
  end;

  writeLn;
end;

Begin
  assign(input, 'input.txt');
  reSet(input);
  assign(output, 'output.txt');
  reWrite(output);

  read(N);
  fillChar(f1, sizeOf(f1), 0);
  fillChar(f2, sizeOf(f2), 0);
  f1.len := 1; f1.num[1] := 2;
  f2.len := 1; f2.num[1] := 1;

  for i := 2 to N do begin
    temp := f1;
    add(f1, f2);
    f2 := temp;
  end;
  print(f1);
End.
