{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}

Program Tr_;
Const Delta=0.000001;
      MaxN=10;
Type real = extended;
     Point=record
       x,y:real
     end;

Var a:array[1..3*MaxN] of Point;
    a_:array[1..3*MaxN] of record
                             x,y:integer
                           end;
    MinT,Tr:array[1..MaxN,1..3] of integer;
    MinS:array[1..3*MaxN] of real;
    Was:array[1..3*MaxN] of boolean;
    i,j,k,n:integer;
    min,MinTr:real;
    time : longint absolute $0000:$046C;
    breakTime : longint;

Procedure Input_;
Var i:integer;
Begin
  Assign(input,'input.txt');
  Reset(input);

  read(n);
  for i:=1 to n do
    read(a[i].x,a[i].y)
End(*Input*);

Procedure MashTab;
Var i:integer;
    MinX,MinY,MaxX,MaxY,kX,kY:real;

Begin
  MinX:=1e28; MinY:=1e28; MaxX:=-1e28; MaxY:=-1e28;

  for i:=1 to n do begin
    if a[i].x<MinX then MinX:=a[i].x;
    if a[i].y<MinY then MinY:=a[i].y;
    if a[i].x>MaxX then MaxX:=a[i].x;
    if a[i].y>MaxY then MaxY:=a[i].y
  end;

  MinX:=MinX-3; MinY:=MinY-3;
  kX:=(639-2)/(MaxX-MinX);
  kY:=(339-2)/(MaxY-MinY);

  for i:=1 to n do begin
    a_[i].x:=round((a[i].x-MinX)*kX);
    a_[i].y:=round((a[i].y-MinY)*kY)
  end
End(*Mashtab*);

Function Sq(i,j,k:integer):real;
Var r:real;
Begin
  r:=abs( a[i].x*(a[k].y-a[j].y)+a[j].x*(a[i].y-a[k].y)+
          a[k].x*(a[j].y-a[i].y) );
  if r<Delta then r:=0;
  Sq:=r
End(*Sq*);

Procedure Zgad;
Var p,i,j,k:integer;
    mn:set of 1..3*MaxN;
    r,q,m:real;
Begin
  mn:=[1..n];
  Min:=0;

  for p:=1 to n div 3 do begin
    q:=1e28; m:=1e20;
    for i:=1 to n-2 do
      if i in mn then
      for j:=i+1 to n-1 do
        if j in mn then
        for k:=j+1 to n do
          if (k in mn) then begin
            r:=Sq(i,j,k);
            if (r<>0) and (r<q) then begin
              MinT[p,1]:=i; MinT[p,2]:=j; MinT[p,3]:=k;
              m:=r
            end
          end;
    mn:=mn-[MinT[p,1]]-[MinT[p,2]]-[MinT[p,3]];
    Min:=Min+m
  end
End(*Zgad*);

Procedure Local;
Const L:array[1..3] of record
                         a,b:byte
                       end
                     = ((a:2;b:3),(a:1;b:3),(a:2;b:1));

Var i,j,p,t,r:integer;
    Min_,a,b:real;
    Label _;
Begin
_:
  for i:=1 to n div 3-1 do
    for k:=i+1 to n div 3 do begin
      Min_:=Min-Sq(MinT[i,1],MinT[i,2],MinT[i,3])-
                Sq(MinT[k,1],MinT[k,2],MinT[k,3]);

      for p:=1 to 3 do
        for t:=1 to 3 do begin
          a:=Sq(MinT[i,L[p].a],MinT[i,L[p].b],MinT[k,t]);
          b:=Sq(MinT[k,L[t].a],MinT[k,L[t].b],MinT[i,p]);
          if (a*b<>0) and (Min_+a+b<Min) then begin
            r:=MinT[i,p];
            MinT[i,p]:=MinT[k,t];
            MinT[k,t]:=r;
            Min:=Min_+a+b;
            Goto _
          end
        end

    end;
End(*Local*);

Procedure Per(t,k:integer;sum:real);
Var i,j:integer;
Begin
  if time > breakTime then exit;

  if (t<n div 3) and (Sum+MinS[t]+MinTr*(n-3*t-3)>=Min) or (Sum>=Min)
   then Exit;

  if t>n div 3 then begin
    MinT:=Tr;
    Min:=Sum;
    Local;
    Exit
  end;

  while not Was[k] do inc(k);

  Tr[t,1]:=k; Was[k]:=false;
  for i:=k+1 to N-1 do
    if Was[i] then
      for j:=i+1 to N do
        if Was[j] and (Sq(i,j,k)<>0) then begin
          Tr[t,2]:=i; Tr[t,3]:=j;
          Was[i]:=false; Was[j]:=false;
          Per(t+1,k+1,Sum+Sq(i,j,k));
          Was[i]:=true; Was[j]:=true
    end;
  Was[k]:=true
End(*Per*);

procedure outAnswer;
var
  i, j : integer;
begin
  assign(output, 'output.txt');
  reWrite(output);

  writeLn(Min/2);

  for i := 1 to n div 3 do
    writeLn(MinT[i,1], ' ', MinT[i,2], ' ', MinT[i,3]);
end;

BEGIN
  breakTime := time + Round(15/55*1000)-3;

  Input_;
  Mashtab;

  for k:=1 to n do begin
    MinS[k]:=1e20;
    for i:=1 to n-1 do
      for j:=i+1 to n do begin
        min:=Sq(i,j,k);
        if (min<>0) and (min<MinS[k]) then
          MinS[k]:=min
      end
  end;

  MinTr:=1e28;
  for i:=1 to n do
    if MinS[i]<MinTr then MinTr:=MinS[i];

  Zgad;

  if Min<1e20 then Local;

  FillChar(Was,SizeOf(Was),$FF);
  Per(1,1,0);
  OutAnswer;
END.
