{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 65520,0,655360}

{ $DEFINE GenAnswer}

Program Day_2_Problem_3;

Const NMax=6;
      MMax=20;

Type O=array[1..Nmax] of byte;
     Sums=array[1..NMax,1..NMax] of byte;
     Sets=Set of byte;

Var N,M,K,Max,Num,Need,Up:integer;
    A:O;
    Best:array[1..100] of O;
    Sum:Sums;
    S,S1:Sets;

Procedure Init;
Begin
  Close(input);
  Assign(input,'input.txt'); ReSet(input);
  read(N,M,K);

  FillChar(A,SizeOf(A),0);
End(*Init*);

Procedure Check;
Var i,j:integer;
Begin
  For i:=3 to N do
    For j:=N-i+2 to N-1 do
      Begin
        Sum[i,j]:=Sum[i,j-1]+A[j-N+i-1];
        Include(S1,Sum[i,j])
      End;

  i:=M;
  While i in S1 do inc(i);

  If i>Max then
    Begin
      Num:=1;
      Best[Num]:=A;
      Max:=i
    End
  Else
    If i=Max then
      Begin
        inc(Num);
        Best[Num]:=A
      End
End(*Check*);

Procedure AddSum(k:integer);
Var i:integer;
Begin
  Sum[k,1]:=A[k];
  Include(S1,A[k]);
  For i:=k-1 downto 1 do
    Begin
      Sum[i,k-i+1]:=Sum[i,k-i]+A[k];
      Include(S1,Sum[i,k-i+1])
    End;
End(*AddSum*);

Function NewUp(k:integer):integer;
Var i:integer;
Begin
  If k<N then NewUp:=Up
  Else
   Begin
     i:=M;
     While i in S1 do inc(i);
     NewUp:=i
   End
End(*NewUp*);

Procedure Solving(k:integer);
Var i,Down,Need_,Up:integer;
    S1_,S_:Sets;
    Sum1:Sums;
Begin
  If k=N+1 then
    Begin
      Check;
      Exit
    End;

  If k=N then Down:=A[2]
  Else Down:=A[1];

  Up:=NewUp(K);
  If (k=N) and (Sum[1,N-1]+Up<Max-1) then
    Exit;

  S1_:=S1;
  Sum1:=Sum;
  Need_:=Need;
  S_:=S;

  For i:=Down to Up do
    If (Need>0) and ((N-k+1)<=Need) and (i in S) or
       (Need=0) or (N-k+1>Need) then
      Begin
        A[k]:=i;
        If (i in S) then
          Begin
            dec(Need);
            Exclude(S,i)
          End;

        AddSum(k);
        Solving(k+1);

        Need:=Need_;
        S:=S_;
        S1:=S1_;
        Sum:=Sum1
      End;
End(*Solving*);

Procedure Solve;
Var i:integer;
Begin
  Max:=M-1;
  Up:=N*(N-1) div 2+M-1;
  Num:=0;
  FillChar(Sum,SizeOf(Sum),0);

  For i:=K to M do
    Begin
      A[1]:=i;
      Sum[1,1]:=i;
      Need:=2*i-M;
      If Need<0 then Need:=0;
      If Need>0 then S:=[M..2*i-1];
      If (i=M) and (Need>0) then
        Begin
          dec(Need);
          Exclude(S,M)
        End;

      S1:=[i];
      If i<>M then dec(Up);
      Solving(2);
      If i<>M then inc(Up)
    End;
End(*Solve*);

Procedure Done;
Var i,j:integer;
Begin
  Close(input); Close(output);
  Assign(output,'Output.txt'); ReWrite(output);

{$IFDEF GenAnswer}
  writeLn(2*Num);
{$ENDIF}

  writeln(Max-1);
  For i:=1 to Num do
    Begin
      For j:=1 to N do write(Best[i,j],' ');
      writeln;
      write(Best[i,1],' ');
      For j:=0 to N-2 do write(Best[i,N-j],' ');
      writeln
    End;

  Close(output)
End(*Done*);

BEGIN
  Init;
  Solve;
  Done
END.
