{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 65384,0,655360}
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$N+}
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=1000;
      MaxM=1000;
      MaxSp=15000;
      epsout=6;
      Dx: Array[1..4] Of Integer=( 0, 0,-1, 1);
      Dy: Array[1..4] Of Integer=(-1, 1, 0, 0);
Type Sset=Set Of 0..7;
     TSmall=Array[0..125] Of SSet;
 Var A: Array[1..MaxN] Of ^TSmall;
     N, M: Integer;
     Max, Min: LongInt;
     rs: Extended;

 Procedure AddA(i, j: Integer);
  Begin
   Include(A[i]^[j shr 3], j And 7);
  End;

 Procedure DeleteA(i, j: Integer);
  Begin
   Exclude(A[i]^[j shr 3], j And 7);
  End;

 Function ExisA(i, j: Integer): Boolean;
  Begin
   ExisA:=(j And 7) In A[i]^[j shr 3];
  End;

 Procedure Init;
  Var i, j, k: Integer;
   Begin
    Assign(Input, InputFile);
     Reset(Input);
      Read(M, N);
      For i:=1 To N Do Begin
       New(A[i]);
       FillChar(A[i]^, SizeOf(A[i]^), 0);
        For j:=1 To M Do Begin
         Read(k);
         If k=1 Then AddA(i, j);
       End;
      End;
     Close(Input);
    Max:=0; Min:=MaxLongInt;
   End;

Var Ox, Oy: Array[1..MaxSp] Of Integer;

 Procedure Delet(Const k, p: Integer; Var rs: LongInt);
  Var nx, ny, dwnf, i, upf, down, up: LongInt;
   Begin
    dwnf:=1; upf:=1; down:=1; up:=1;
    Ox[1]:=k; Oy[1]:=p; DeleteA(k, p);
    Repeat
     For i:=1 To 4 Do Begin
      nx:=Ox[dwnf]+Dx[i]; ny:=Oy[dwnf]+Dy[i];
      If (nx>0) And (ny>0) And (nx<=N) And (ny<=M) And ExisA(nx, ny) Then Begin
       DeleteA(nx, ny);
       Inc(up);
       upf:=upf Mod MaxSp + 1;
       Ox[upf]:=nx;
       Oy[upf]:=ny;
      End;
     End;
      Inc(down);
      dwnf:=dwnf Mod MaxSp + 1;
    Until down>up;
    rs:=up;
   End;

 Procedure Solve;
  Var i, j: Integer;
      rs: LongInt;
   Begin
    For i:=1 To N Do
    For j:=1 To M Do
     If ExisA(i, j) Then Begin
       Delet(i, j, rs);
       If rs<Min Then Min:=rs;
       If rs>Max Then Max:=rs;
     End;
   End;

 Procedure Done;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      If Max=0 Then WriteLn(0)
       Else Begin
         rs:=Max/Min;
         WriteLn(rs:0:epsout);
       End;
     Close(Output);
   End;

BEGIN
 Init;
  Solve;
 Done;
END.