{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
Program Lusue;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxSp=3000;
      MaxN=1000;
Type TPl=Record
{          WhR: Integer;}
          lf, rg, ifl: Boolean;
          WhPri: Integer;
         End;
     BMas=Array[1..3000] Of Record
           nm, WhPri: Integer;
          End;
 Var A: Array[1..MaxSp] Of TPl;
     Plov: Array[1..MaxN] Of Integer;
     sc: Array[-1..5] Of LongInt;
     Sp: Array[3..5] Of ^BMas;
     N, K: Integer;
     Res: Array[1..MaxSp] Of Integer;


 Procedure ReadSmb(Var ch: Char);
  Begin
    Read(ch);
    While ch In [#0..#25, #27..#32] Do Read(ch);
  End;

 Procedure Init;
  Var i: Integer;
      ch: Char;
      nm, sc: Integer;
      rc, rd: Char;
   Begin
    New(Sp[3]);
    New(Sp[4]);
    New(Sp[5]);
    Assign(Input, InputFile);
     Reset(Input);
      ReadLn(N, K); sc:=0;
      For i:=1 To 2*K Do Begin
       ReadSmb(ch);
       Read(nm);
       ReadSmb(rc);
       ReadSmb(rd);
        If ch='+' Then Begin
          Inc(sc);
           Plov[nm]:=sc;
{           A[sc].WhR:=sc;}
           A[sc].lf:=rc='';
           A[sc].ifl:=rd='';
         End
        Else Begin
         A[Plov[nm]].rg:=rc='';
         A[Plov[nm]].WhPri:=i;
        End;
      End;
     Close(Input);
   End;

 Procedure AddOch(Const aa: Integer;Const k: Integer);
  Var nm: Integer;
   Begin
    Inc(sc[aa]);
     nm:=sc[aa];
    Sp[aa]^[nm].WhPri:=A[k].WhPri;
    Sp[aa]^[nm].nm:=k;
   End;

 Function FindMax(Const aa: Integer): Integer;
  Var i, mx, rs: Integer;
   Begin
    mx:=-1;
    For i:=1 To sc[aa] Do
    If Sp[aa]^[i].WhPri>mx Then Begin
     rs:=i;
     mx:=Sp[aa]^[i].WhPri;
    End;
    FindMax:=rs;
   End;

 Procedure DelOch(Const aa, bb: Integer);
  Var i: Integer;
   Begin
    Dec(sc[aa]);
    For i:=bb To sc[aa] Do Sp[aa]^[i]:=Sp[aa]^[i+1];
   End;

 Procedure AddSong(Const k: Integer);
  Var aa, nd: Integer;
   Begin
    aa:=Byte(A[k].lf) + 1;
     Res[k]:=1;
    If sc[aa]>0 Then Dec(sc[aa])
     Else
    If sc[aa+2]>0 Then Begin
      nd:=FindMax(aa+2);
       Res[Sp[aa+2]^[nd].nm]:=0;
      DelOch(aa+2, nd);
     End
    Else
     If sc[5]>0 Then Begin
      nd:=Sp[5]^[sc[5]].nm;
      Res[nd]:=Byte(A[nd].lf<>A[k].lf);
      DelOch(5, sc[5]);
     End
    Else Inc(sc[aa-2]);
   End;

 Procedure AddNoSong(Const k: Integer);
  Var aa, nd, np: Integer;
   Begin
    If Not(A[k].lf xor A[k].rg) Then Exit;
     aa:=Byte(A[k].lf) + 1;
    If sc[aa]>0 Then Begin
      Res[k]:=1;
      AddOch(aa+2, k);
      Dec(sc[aa]);
     End
    Else
     If sc[aa+2]>0 Then Begin
      Inc(aa, 2);
      nd:=FindMax(aa); np:=Sp[aa]^[nd].nm;
      If A[k].WhPri<A[np].WhPri Then Begin
        Res[np]:=0;
         Res[k]:=1;
        Sp[aa]^[nd].nm:=k;
        Sp[aa]^[nd].WhPri:=A[k].WhPri;
       End;
     End;
   End;

 Procedure DelSong(Const k: Integer);
  Begin
   Inc(sc[Byte(A[k].rg)+1]);
  End;

 Function GetNum(Const aa: Integer; Const pr: Integer): Integer;
  Var i: Integer;
   Begin
    GetNum:=1;
    For i:=1 To sc[aa] Do
    If Sp[aa]^[i].WhPri=pr Then Begin
      GetNum:=i;
      Exit;
     End;

    {??????}
   End;

 Procedure DelNoSong(Const k: Integer);
  Var aa: Integer;
   Begin
    If Res[k]=0 Then Exit;
     aa:=Byte(A[k].lf)+3;
     DelOch(aa, GetNum(aa, A[k].WhPri));
    AddOch(5, k);
   End;

 Procedure Solve;
  Var i, sp: Integer;
      ch: Char;
      nm: Integer;
      rc, rd: Char;

   Begin
    FillChar(sc, SizeOf(sc), 0);
    FillChar(Res, SizeOf(Res), 0);
    Assign(Input, InputFile);
     Reset(Input); sp:=0;
      ReadLn(N, K);
      For i:=1 To 2*K Do Begin
       ReadSmb(ch);
       Read(nm);
       ReadSmb(rc);
       ReadSmb(rd);
        If ch='+' Then Begin
           Inc(sp);
           Plov[nm]:=sp;
           If A[sp].ifl Then AddSong(sp)
            Else AddNoSong(sp);
         End
        Else Begin
         If A[Plov[nm]].ifl Then DelSong(Plov[nm])
          Else DelNoSong(Plov[nm]);
        End;
      End;

     Close(Input);
   End;

 Procedure Done;
  Var i: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      WriteLn(sc[-1], ' ', sc[0]);
      For i:=1 To K Do WriteLn(Res[i]);
     Close(Output);
   End;

BEGIN
 Init;
  Solve;
 Done;
END.