{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 63384,0,655360}

program Ham;

type Tarray = array [0..40320] of byte;
     Parray = ^Tarray;

const bb: string [9] = ' ';
const f: array [1..7] of word = (1,2,6,24,120,720,5040);
var u, a: array [1..9] of byte;
    m: array [1..9] of PArray;
 i, j, x, y, z, t: word;
 st: array [1..100] of word;
 sp: byte;
 xx, yy: word;
   mrk: longint;
   did: boolean;
   cnt: longint;

procedure MakeI (var a: byte; c: char);
begin
  if c = '' then a := 1;
  if c = '' then a := 2;
  if c = '' then a := 3;
  if c = '' then a := 4;
  if c = '' then a := 5;
  if c = '' then a := 7;
  if c = '' then a := 8;
  if c = ' ' then a := 9;
end;

procedure Print;
var i, j: integer;
    ch: char;
begin
  for i := 1 to 9 do
  begin
    write(bb[a[i]],' '); if i mod 3 = 0 then writeln;
  end;
end;

procedure GetNumber (var x, y: word);
var i, j, k: word;
begin
  FillChar (u, sizeof(u), 0);
  for i := 1 to 9 do
    if a[i] = 9 then break;
  x := i;
  u[x] := 1;
  y := 0;
  for i := 8 downto 2 do
  begin
    k := 1;
    j := 1;
    while a[j] <> i do
    begin
      if u[j] = 0 then
      inc (k);
      inc (j);
    end;
    y := y + (k-1) * f[i-1];
    u[j] := 1;
  end;
end;

procedure MakePos (x, y: word);
var i, j, k: word;
begin
  FillChar (u, sizeof(u), 0);
  FillChar (a, sizeof(a), 1);
  u[x] := 1;
  a[x] := 9;
  for i := 8 downto 2 do
  begin
    j := 1;
    k := y div f[i-1]+1;
    while k > 0 do
    begin
      if u[j] = 0 then dec (k);
      inc (j);
    end;
    dec (j);
    a[j] := i;
    u[j] := 1;
    y := y mod f[i-1];
  end;
end;

procedure Prepare;
var i: integer;
begin
  for i := 1 to 9 do new(m[i]);
  for i := 1 to 9 do FillChar(m[i]^, Sizeof(m[i]^), 255);
  for i := 1 to 9 do a[i] := i;
  GetNumber (x, y);
  m[x]^[y] := 0;
  a[4] := 6;
  a[6] := 4;
  GetNumber (x, y);
  m[x]^[y] := 0;
end;

procedure Swap (i, j: byte);
begin
  a[i] := a[j];
  a[j] := 9;
end;

procedure DoMoves (x, y: word; s: byte);
var x1, y1: word;
begin
  did := true;
  MakePos (x, y);
  if (x <> 1) and (x<>4) and (x<>7) then
    begin
      {print;}
      Swap (x, x-1);
      {print;}
      GetNumber (x1, y1);
      if m[x1]^[y1] > (s+1) then {begin }m[x1]^[y1] := s+1; {inc (mrk);end;}
      Swap (x-1, x);
    end;
  if (x <> 3) and (x<>6) and (x<>9) then
    begin
      {print;}
      Swap (x, x+1);
      {print;}
      GetNumber (x1, y1);
      if m[x1]^[y1] > (s+1) then {begin} m[x1]^[y1] := s+1; {inc (mrk);end;}
      Swap (x+1, x);
    end;
  if x > 3 then
    begin
      {print;}
      Swap (x, x-3);
      {print;}
      GetNumber (x1, y1);
      if m[x1]^[y1] > (s+1) then {begin} m[x1]^[y1] := s+1; {inc (mrk);end;}
      Swap (x-3, x);
    end;
  if x < 7 then
    begin
      {print;}
      Swap (x, x+3);
      {print;}
      GetNumber (x1, y1);
      if m[x1]^[y1] > (s+1) then {begin }m[x1]^[y1] := s+1; {inc (mrk);end;}
      Swap (x+3, x);
    end;
 inc (cnt);
end;

procedure Push(a: word);
begin
 inc (sp);
 st[sp] := a;
end;

procedure DoMove (s: byte);
var x1, y1: word;
begin
  GetNumber (x, y);
  if (x <> 1) and (x<>4) and (x<>7) then
    begin
      Swap (x, x-1);
      GetNumber (x1, y1);
      if m[x1]^[y1] < s then begin Push(x1); exit;end;
      Swap (x-1, x);
    end;
  if (x <> 3) and (x<>6) and (x<>9) then
    begin
      Swap (x, x+1);
      GetNumber (x1, y1);
      if m[x1]^[y1] < s then begin Push(x1); exit;end;
      Swap (x+1, x);
    end;
  if x > 3 then
    begin
      Swap (x, x-3);
      GetNumber (x1, y1);
      if m[x1]^[y1] < s then begin Push(x1); exit;end;
      Swap (x-3, x);
    end;
  if x < 7 then
    begin
      Swap (x, x+3);
      GetNumber (x1, y1);
      if m[x1]^[y1] < s then begin Push(x1); exit;end;
      Swap (x+3, x);
    end;
end;

procedure Think;
var s: byte;
    x, y: word;
begin
  Prepare;
{  mrk := 0;}
  for s := 0 to 254 do
  begin
    did := false;
    for x := 1 to 9 do
      for y := 0 to 40319 do
        if m[x]^[y] = s then
          DoMoves (x, y, s);
    if m[xx]^[yy] < 255 then exit;
    if did = false then exit;
  end;
end;

procedure OutSeq;
var x, y: word;
begin
  sp := 0;
  getnumber (x, y);
  while m[x]^[y] > 0 do
  begin
    DoMove (m[x]^[y]);
    getnumber (x, y);
  end;
  writeln (sp);
  for i := 1 to sp do
    writeln((st[i]-1) div 3 + 1,' ', (st[i]-1) mod 3 +1);
end;

procedure NoSol;
begin
  writeln(' 襭');
  close (output);
  halt;
end;

procedure ReadAll;
var s: string;
    i: integer;
    n: array [1..9] of byte;
begin
  assign (input, 'input.txt'); reset (input);
  readln (s); for i := 1 to 3 do Makei(a[i], s[i]);
  readln (s); for i := 1 to 3 do Makei(a[i+3], s[i]);
  readln (s); for i := 1 to 3 do Makei(a[i+6], s[i]);
  cnt := 0;
  for i := 9 downto 1 do
    if a[i] = 4 then begin a[i] := 6; break; end;
  for i := 1 to 9 do n[i] := 0;
  for i := 1 to 9 do inc (n[a[i]]);
  for i := 1 to 9 do if n[i] <> 1 then NoSol;
  GetNumber (xx, yy);
  Think;
  MakePos (xx, yy);
  OutSeq;
  close (input);
end;

begin
  assign (output, 'output.txt'); rewrite (output);
  ReadAll;
  close (output);
end.
