{ Poezda }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

const eps = 1e-10;
type float = extended;
var l0, t0, a, s, v: float;
    k, N: integer;
    r, t1: array [1..100] of float;
    mt, T: float;

function TimeOf(l: float): float;
begin
  if l <= l0 then
    TimeOf := 2*sqrt(l/a)
  else
    TimeOf := 2*t0 + (l-l0) / v;
end;

procedure ReadAll;
var i: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(N);
  r[1] := 0;
  for i := 2 to N do
    Read(r[i]);
  Read(a, v, s);
  l0 := sqr(v) / a;
  t0 := v / a;
end;

procedure Solve;
var i: integer;
    T_1, T_2, gt, x, l, d: float;
begin
  t1[1] := 0;
  for i := 2 to N do
    t1[i] := t1[i-1] + TimeOf(r[i]-r[i-1]) + s;

  T := 0.5*(t1[N] - s);
  for k := 2 to N do
    if t1[k] >= T then break;
  if T >= t1[k] - s then begin
    { On the station }
    d := r[k];
    T_1 := t1[k] - s;
    T_2 := 2*T-t1[k];
    if T_1 > T_2 then t := T_1 else t := T_2;
  end else begin
    x := T - t1[k-1];
    l := r[k] - r[k-1];
    mt := TimeOf(l);
    if l < l0 then gt := mt*0.5 else gt := t0;
    if x <= gt then
      d := r[k-1] + a*Sqr(x)*0.5
    else
    if x >= mt - gt then
      d := r[k] - a*Sqr(mt-x)*0.5
    else
      d := r[k-1] + l0*0.5 + (x-t0)*v;
  end;
  Writeln(d:0:2, ' ', T:0:2);
end;

begin
  ReadAll;
  Solve;
end.