{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
{
 襭  " "
 22  1998.  ᫠.
 V. Berov
}

Program Hacker_Of_Net;

Const NMax=750;

Type PKnot = ^TKnot;
     TKnot = Record
               N:Integer;
               Next:PKnot;
             End;

Var A:Array[1..NMax] of PKnot; { ॢ }
    Weight:Array[1..NMax] of LongInt; {  }
    N:Integer;

Procedure New(Var q:PKnot);
Begin
  System.New(q);
  q^.N:=0;
  q^.Next:=Nil;
End;

Procedure Init;
Var i,k:Integer;
    q:PKnot;
Begin
  Assign(Input,'Input.txt');
  ReSet(Input);

  ReadLn(N);
  For i:=1 to N do A[i]:=Nil;

  For i:=1 to N do Begin
    While Not SeekEoLn do Begin
      Read(K);
      If A[i]=Nil then Begin
        New(A[i]);
        q:=A[i]
      End
      Else Begin
        New(q^.next);
        q:=q^.next;
      End;

      q^.N:=K;
    End;

    ReadLn;
  End;

  for i:=1 to N do Read(Weight[i]);

  Close(Input);
End;

Var Best:Array[1..NMax] of LongInt;  { 訩  }
    Take:Array[1..NMax] of Boolean;  { ६   }
    Hand:Array[1..NMax] of PKnot;    { 襭 ॢ }
    St:Array[1..NMax] of Integer;    { । }
    Edge:Array[1..NMax] of Integer;  { ⢮ ࠡ⠭ ᥤ }
    NotWas:Array[1..NMax] of Boolean;   { ਧ ࠡ⠭ }
    hSt,lSt:Integer;

Procedure Push(i:Integer);
Begin
  Inc(hSt);
  St[hSt]:=i;
End;

Procedure Solve;
Var i:Integer;
    q,p:PKnot;
    j:LongInt;
Begin
  for i:=1 to N do begin
    Hand[i]:=Nil;
    Best[i]:=-1;
  end;
  FillChar(NotWas,SizeOf(NotWas), True);

  hSt:=0; lSt:=1;
  for i:=1 to N do begin
    Edge[i]:=0;
    q:=A[i];
    while q<>Nil do begin
      inc(Edge[i]);
      q:=q^.Next;
    end;

    if Edge[i]=1 then begin
      Push(i);
      Best[i]:=0;
      Take[i]:=False;
    end;
  end;

  while (lst<=hSt) do begin
    i:=St[lSt]; Inc(lSt);
    NotWas[i]:=False;

    {   ॢ  ࠡ ᥤ }
    q:=A[i];
    while q<>Nil do begin
      dec(Edge[q^.N]);
      if NotWas[q^.N] then begin
        new(p);
        p^.next:=Hand[q^.N];
        Hand[q^.N]:=p;
        p^.N:=i;
      end;

      if Edge[q^.N]=1 then Push(q^.N);
      q:=q^.Next;
    end;

    { 宦 襭   ॢ}
    { ६ 設 }
    if Best[i]<0 then begin
      q:=Hand[i];
      Best[i]:=Weight[i];
      while q<>Nil do begin
        Inc(Best[i], Best[q^.N]);
        q:=q^.next;
      end;

      {  ६ 設 }
      j:=0;
      q:=Hand[i];
      while q<>Nil do begin
        Inc(j, Weight[q^.N]);
        p:=Hand[q^.N];
        while p<>Nil do begin
          Inc(j, Best[p^.N]);
          p:=p^.next;
        end;

        q:=q^.Next;
      end;

      if Best[i]<j then  Take[i]:=True
      else begin
        Take[i]:=False;
        Best[i]:=j;
      end;
    end;
  end;
End;

Procedure Print;
Var List:Array[1..NMax] of Boolean;
    i:Integer;
    q,p:PKnot;
begin
  Assign(Output,'Output.txt');
  ReWrite(Output);

  if N=2 then begin
    if Weight[1]<Weight[2] then WriteLn(Weight[1],' ',1)
    else WriteLn(Weight[2],' ',2);

    exit;
  end;

  Writeln(Best[St[N]]);

  FillChar(List, SizeOf(List), 0);
  hSt:=1; St[1]:=St[N];
  while hSt<>0 do begin
    i:=St[hSt]; Dec(hSt);

    { ६ }
    if Take[i] then begin
      List[i]:=True;

      q:=Hand[i];
      while q<>Nil do begin
        Push(q^.N);
        q:=q^.Next;
      end;
    end
    {  ६ }
    else begin
      q:=Hand[i];
      while q<>Nil do begin
        List[q^.N]:=True;

        p:=Hand[q^.N];
        while p<>Nil do begin
          Push(p^.N);
          p:=p^.Next;
        end;

        q:=q^.Next;
      end;
    end;
  end;

  for i:=1 to N do
    if List[i] then Write(i,' ');

  Close(Output);
end;

Begin
  Init;
  if N<>2 then
    Solve;
  Print;
End.
