{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}
Const
  MaxK=100;
  MaxL=100;
  MaxLen=12;
  FlagAdd=1000000000;
  MaxLong=16;
Type
  TReactArr=Array[1..MaxK]Of Record
    Src:Byte;
    Dst:Array[1..MaxK]Of Boolean;
  End;
  TLong=Array[1..MaxLong]Of Word;
Var
  Infinity:TLong;
  K:Byte;
  L:Byte;
  Name:Array[1..MaxK]Of String[MaxLen];
  React,RSave:TReactArr;
  HowMany:Array[1..MaxK]Of TLong;
  Was:Array[1..MaxK]Of Boolean;
  Plumbum,Aurum:Byte;
  Result:TLong;
Procedure LongOne(Var L:TLong);
Begin
  FillChar(L,SizeOf(L),0);
  L[MaxLong]:=1;
End;
Procedure LongZero(Var L:TLong);
Begin
  FillChar(L,SizeOf(L),0);
End;
Procedure LongAdd(Var A,B:TLong);
Var
  R,P,I:LongInt;
Begin
  P:=0;
  For I:=MaxLong DownTo 1 Do Begin
    R:=A[I]+B[I]+P;
    If R>=10000 Then Begin
      A[I]:=R-10000;
      P:=1;
    End Else Begin
      A[I]:=R;
      P:=0;
    End;
  End;
End;
Function Compare(Var A,B:TLong):ShortInt;
Var
  I:Byte;
Begin
  For I:=1 To MaxLong Do
    If A[I]<B[I] Then Begin Compare:=-1; Exit; End Else If A[I]>B[I] Then Begin Compare:=1; Exit; End;
  Compare:=0;
End;
Function GreaterZero(Var L:TLong):Boolean;
Var
  I:Byte;
Begin
  GreaterZero:=True;
  For I:=1 To MaxLong Do If L[I]>0 Then Exit;
  GreaterZero:=False;
End;
Procedure WriteLong(Var L:TLong);
Var
  I:Byte;
Begin
  For I:=1 To MaxLong Do If L[I]>0 Then Break;
  Write(L[I]);
  For I:=I+1 To MaxLong Do Begin
    If L[I]<1000 Then Write('0');
    If L[I]<100 Then Write('0');
    If L[I]<10 Then Write('0');
    Write(L[I]);
  End;
  WriteLn;
End;
Function UpCase(C:Char):Char;
Begin
  Case C Of
    ''..'':Dec(C,32);
    ''..'':Dec(C,80);
    'a'..'z':Dec(C,32);
  End;
  UpCase:=C;
End;
Function SCompare(Var S1,S2:String):Boolean;
Var
  I:Byte;
Begin
  SCompare:=False;
  For I:=1 To Length(S1) Do If UpCase(S1[I])<>UpCase(S2[I]) Then Exit;
  SCompare:=True;
End;
Function Which(S:String):Byte;
Var
  I:Byte;
Begin
  For I:=1 To K Do If SCompare(S,Name[I]) Then Begin Which:=I; Exit; End;
  Which:=0;
End;
Procedure Load;
Var
  C:Char;
  S:String;
  I,J:Byte;
  Buf:Pointer;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  GetMem(Buf,65535);
  SetTextBuf(Input,Buf^,65534);
  ReadLn(K);
  J:=1;
  S:='';
  While Not EOLN Do Begin
    Read(C);
    If C=' ' Then Begin
      If S<>'' Then Begin
        Name[J]:=S;
        Inc(J);
        S:='';
      End;
    End Else S:=S+C;
  End;
  If S<>'' Then Name[J]:=S;
  ReadLn;
  ReadLn(L);
  For I:=1 To L Do Begin
    ReadLn(S);
    React[I].Src:=Which(S);
    FillChar(React[I].Dst,SizeOf(React[I].Dst),False);
    S:='';
    While Not EOLN Do Begin
      Read(C);
      If C=' ' Then Begin
        If S<>'' Then Begin
          React[I].Dst[Which(S)]:=True;
          S:='';
        End;
      End Else S:=S+C;
    End;
    If S<>'' Then React[I].Dst[Which(S)]:=True;
    ReadLn;
  End;
  Close(Input);
  FreeMem(Buf,65535);
  Plumbum:=Which('ᢨ');
  Aurum:=Which('');
End;
Procedure Run;
Var
  Stack:Array[1..MaxK+1]Of Byte;
  CC,LL:TLong;
  F:Byte;
Procedure Count(A,Gl:Byte; Var Result:TLong; Var Flag:Byte);
Var
  Max,Sum,Res:TLong;
  I,J,II,JJ:Byte;
  BadSet,CorrSet:Set Of Byte;
  Infin:Set Of Byte;
  BadNum:Byte;
  InMul:Boolean;
Label StartIt,DelCycle;
Begin
  Stack[Gl]:=A;
  Flag:=0;
  For I:=1 To Gl-1 Do If Stack[I]=A Then Begin
    Flag:=A;
    Exit;
  End;
  If (Gl>1) And Was[A] Then Result:=HowMany[A] Else Begin
    InMul:=False;
    Goto StartIt;
    DelCycle:
    BadSet:=[A];
    CorrSet:=[A];
    InFin:=[];
    For I:=Gl To K Do If Stack[I+1]=A Then Break Else Include(BadSet,Stack[I+1]);
    For II:=1 To L Do If React[II].Src In BadSet Then Begin
      BadNum:=0;
      For JJ:=1 To K Do If React[II].Dst[JJ] And (JJ In BadSet) Then Inc(BadNum);
      If BadNum>0 Then Begin
        For JJ:=1 To K Do If React[II].Dst[JJ] And (Not (JJ In BadSet) Or (BadNum>1)) Then Begin
          If JJ In BadSet Then InFin:=InFin+[A] Else InFin:=InFin+[JJ];
        End;
        If React[II].Src In CorrSet Then React[II].Src:=0 Else Begin
          FillChar(React[II].Dst,SizeOf(React[II].Dst),False);
          React[II].Dst[A]:=True;
          Include(CorrSet,React[II].Src);
        End;
      End Else React[II].Src:=A;
    End;
    If Aurum In BadSet Then Begin
      Aurum:=A;
      If A In InFin Then Begin Result:=Infinity; HowMany[A]:=Infinity; Exit; End;
      LongOne(HowMany[A]);
      LongOne(Result);
      Exit;
    End;
    For I:=1 To K Do If I In InFin Then
      If I=A Then InMul:=True Else Begin
        Count(I,Gl+1,Res,Flag);
        If (Flag=0) And GreaterZero(Res) Then Begin Result:=Infinity; HowMany[A]:=Infinity; Exit; End;
        Flag:=0;
      End;
    StartIt:
    Was[A]:=True;
    LongZero(Max);
    For I:=1 To L Do If React[I].Src=A Then Begin
      LongZero(Sum);
      For J:=1 To K Do If React[I].Dst[J] Then Begin
        Count(J,Gl+1,Res,Flag);
        If Compare(Res,Infinity)=0 Then Begin Result:=Infinity; HowMany[A]:=Infinity; Exit; End;
        If Flag>0 Then Begin
          If Flag=A Then Begin
            Goto DelCycle;
          End Else Begin Result:=Res; Exit; End;
        End;
        If GreaterZero(Res) And InMul Then Begin HowMany[A]:=Infinity; Result:=Infinity; Exit; End;
        LongAdd(Sum,Res);
      End;
      If Compare(Sum,Max)>0 Then Max:=Sum;
    End;
    HowMany[A]:=Max;
    Result:=Max;
  End;
End;
Begin
  FillChar(Infinity,SizeOf(Infinity),39);
  FillChar(HowMany,SizeOf(HowMany),0);
  FillChar(Was,SizeOf(Was),False);
  Was[Aurum]:=True;
  LongOne(HowMany[Aurum]);
  RSave:=React;
  Count(Aurum,1,CC,F);
  LongOne(LL);
  If Compare(CC,LL)>0 Then Begin
    FillChar(HowMany,SizeOf(HowMany),0);
    FillChar(Was,SizeOf(Was),False);
    Was[Aurum]:=True;
    LongOne(HowMany[Aurum]);
    React:=RSave;
    Count(Plumbum,1,Result,F);
    If GreaterZero(Result) Then Result:=Infinity;
  End Else Begin
    FillChar(HowMany,SizeOf(HowMany),0);
    FillChar(Was,SizeOf(Was),False);
    Was[Aurum]:=True;
    LongOne(HowMany[Aurum]);
    React:=RSave;
    Count(Plumbum,1,Result,F)
  End;
End;
Procedure Save;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  If Compare(Result,Infinity)=0 Then WriteLn('QUANTUM SATIS') Else WriteLong(Result);
  Close(Output);
End;
Begin
  Load;
  Run;
  Save;
End.