Program Bar02_3;

{ Finding the skyline }

Const
  eps=1E-8;

Var
  X,DX,DY:Array[1..100] of Real;
  N:Integer;
  P:Array[1..1000,1..2] of Real;
  PCount:Integer;

Procedure Input;
  Var
    F:Text;
    S:String;
    I,J,K,L:Integer;
  Begin
    Assign(F,'Input.txt'); ReSet(F); Read(F,N);
    For I:=1 to N do
      Read(F,X[i],Dx[i],Dy[i]);
    Close(F);
  End;

Procedure Add(x,y:Real);
  Begin
    Inc(PCount);
    P[PCount][1]:=X; P[PCount][2]:=Y;
  End;

Procedure SolveIt;
  Var
    XX,YY:Array[1..1000] of Real;
    XS:Integer;
    I,J,K,L:Integer;
    R,T:Real;

  Procedure AXX(x:Real);
    Begin
      Inc(XS); XX[XS]:=x;
    End;

  Begin
    XS:=0;
    For I:=1 to N do
    Begin
      AXX(X[i]); AXX(X[i]+dX[i]);
    End;
    For I:=1 to XS-1 do
      For J:=i+1 to XS do
        if XX[i]>XX[j] then
        Begin
          R:=XX[i]; XX[i]:=XX[j]; XX[j]:=R;
        End;
    For I:=XS-1 downto 1 do
      if abs(XX[i]-XX[i+1])<eps then
      Begin
        For j:=i to xs-1 do
          XX[j]:=XX[j+1];
        Dec(XS);
      End;
    PCount:=0; Add(XX[1],0);
    For I:=1 to XS-1 do
    Begin
      R:=0; T:=(XX[i]+XX[i+1])/2;
      For J:=1 to N do
        if (T>X[j]) and (T<X[j]+dX[j]) then
          if R<dY[j] then
            R:=dY[j];
      Add(XX[i],R); Add(XX[i+1],R);
    End;
    Add(XX[XS],0);
  End;

Function E(x,y:Real):Boolean;
  Begin
    E:=abs(x-y)<eps;
  End;

Procedure ClearIt;
  Var
    I,J:Integer;
  Begin
    For I:=PCount-1 downto 2 do
    Begin
      if (e(P[i][1],P[i-1][1]) and e(P[i][1],P[i+1][1])) or
         (e(P[i][2],P[i-1][2]) and e(P[i][2],P[i+1][2])) then
      Begin
        For J:=i to PCount-1 do
          P[j]:=P[j+1];
        Dec(PCount);
      End;
    End;
  End;

Procedure PrintIt;
  Var
    F:Text;
    I:Integer;
  Begin
    Assign(F,'output.txt'); ReWrite(F);
    Writeln(F,PCount);
    For I:=1 to PCount do
      Writeln(F,P[i][1]:0:10,' ',P[i][2]:0:10,' ');
    Close(F);
  End;

Begin
  Input;
  SolveIt;
  ClearIt;
  PrintIt;
End.

